#!/usr/bin/env python
# ----------------------------------------------------------------------
#
# Extend 2D models generated by build_simple_synthetic_model_2D.py to 3D
# assuming simple lateral invariance over y-axis.
#
# See build_simple_synthetic_model_3D.py for generating fully-3D models.
#
# Francois Lavoue, 28 May 2019
# Last updated FL, 24 Sep. 2019
#
# ----------------------------------------------------------------------
#
# Notes:
#
# - Structure of the input file:
#
#     dir_in          # input directory containing 2D models
#     dir_ou          # output directory for 3D models
#     0.0  20.0  0.1  # ymin, ymax, dy (in m)
#     bin_sem46       # output format: "bin_sem46" or "ascii_specfem"
#
# (beware of the order, [z,x,y], both for 2D/3D management and for compatibility with SEM array format)
#
# ----------------------------------------------------------------------

#-- uncomment this for Python2 forward compatibility
from __future__ import print_function

#-- import modules
import matplotlib.pyplot as plt
from mpl_toolkits.axes_grid1 import make_axes_locatable
import numpy as np
import os
import shutil
import struct

#-- user parameters
file_in1 = "extend_2D_model_to_3D.in"

# debug options
debug = False

if debug:
    fid_debug = open("debug.out",'w')


#-- read input files

# read input/output dirs in extend_2D_model_to_3D.in
fid1 = open(file_in1,'r')
line = fid1.readline().strip().split()   # read 1st line
dir_in = str(line[0])
line = fid1.readline().strip().split()   # read 2nd line
dir_ou = str(line[0])
print("dir_in = %s"   % dir_in)
print("dir_ou = %s\n" % dir_ou) 

# read 2D domain boundaries (x,z) in $dir_in/build_simple_synthetic_model_2D.in
file_in2 = dir_in + "/build_simple_synthetic_model_2D.in"
fid2 = open(file_in2,'r')
line = fid2.readline().strip().split()   # skip 1st line
line = fid2.readline().strip().split()   # read 2nd line
zmin = np.float(line[0])
zmax = np.float(line[1])
dz   = np.float(line[2])
line = fid2.readline().strip().split()   # read 3rd line
xmin = np.float(line[0])
xmax = np.float(line[1])
dx   = np.float(line[2])

# read 3D domain boundaries (y) in extend_2D_model_to_3D.in
line = fid1.readline().strip().split()   # read 3rd line
ymin = np.float(line[0])
ymax = np.float(line[1])
dy   = np.float(line[2])

print("zmin, zmax, dz =", zmin, zmax, dz)
print("xmin, xmax, dx =", xmin, xmax, dx)
print("ymin, ymax, dy =", ymin, ymax, dy)

# read output format in extend_2D_model_to_3D.in
line = fid1.readline().strip().split()   # read 4th line
output_format = str(line[0])
print("\noutput_format = %s", output_format)

# read nb of interfaces in $dir_in/build_simple_synthetic_model_2D.in
line = fid2.readline().strip().split()
n_int = np.int_(line[0])
print("nb of interfaces =",n_int)
# skip interfaces/layers properties
for i_int in range(0,n_int):
    line = fid2.readline().strip().split()

# read nb of layers with gradients in $dir_in/build_simple_synthetic_model_2D.in
line = fid2.readline().strip().split()
n_int_grad = np.int_(line[0])
# skip layers properties
for i_int in range(0,n_int_grad):
    line = fid2.readline().strip().split()

# read nb of "bumpy" interfaces
line = fid2.readline().strip().split()
n_bumpy = np.int_(line[0])
print("nb of bumpy interfaces =",n_bumpy)

# read properties of "bumpy" interfaces
# (needed to compute topography zmin, and therefore nz)
flag_bumpy = np.zeros(n_int)   # are the interfaces "bumpy"? (yes/no)
x0_bumps = np.zeros(n_int)     # bump x-locations
sigma_bumps = np.ones(n_int)   # widths (stds) of the Gaussian bumps
amp_bumps = np.zeros(n_int)    # bump heights
amp_bump_topo = 0.             # topographical bump (for correcting z_min later on)
for i_bump in range(0,n_bumpy):
    line = fid2.readline().strip().split()       # read new line in input file
    i_int_bumpy = np.int_(line[0])              # index of "bumpy" interface
    flag_bumpy[i_int_bumpy] = 1                 # this interface is "bumpy"
    x0_bumps[i_int_bumpy] = np.float(line[1])   # bump x-location
    sigma6_bump_tmp = np.float(line[2])         # bump width (given as 6*sigma of the Gaussian)
    amp_bump_tmp = np.float(line[3])            # bump height
    if i_int_bumpy==0 and amp_bump_tmp>0:       # remember (positive) topographical bump for correcting z_min later on
        amp_bump_topo = amp_bump_tmp

    # convert bumps widths (input widths are given as 6*sigma)
    sigma_bumps[i_int_bumpy] = sigma6_bump_tmp / 6.

    # compute Gaussian amplitude coefficients in order to match the true heights given in input
    x_tmp = np.arange(-sigma_bumps[i_int_bumpy],sigma_bumps[i_int_bumpy],sigma_bumps[i_int_bumpy]/100)
    g_tmp = np.exp( -np.square(x_tmp) / (2*sigma_bumps[i_int_bumpy]**2) ) / np.sqrt(2*np.pi*sigma_bumps[i_int_bumpy]**2)
    amp_bumps[i_int_bumpy] = amp_bump_tmp / g_tmp.max()

# read nb of "wavy" interfaces
line = fid2.readline().strip().split()
n_wavy = np.int_(line[0])
print("nb of wavy interfaces =",n_wavy)

# read properties of "wavy" interfaces
# (needed to compute topography zmin, and therefore nz)
flag_wavy = np.zeros(n_int)    # are the interfaces "wavy"? (yes/no)
lambda_wavs = np.ones(n_int)   # wavelengths of the undulations
amp_wavs = np.zeros(n_int)     # amplitudes of the undulations
for i_wavy in range(0,n_wavy):
    line = fid2.readline().strip().split()         # read new line in input file
    i_int_wavy = np.int_(line[0])                 # index of "wavy" interface
    flag_wavy[i_int_wavy] = 1                     # this interface is "wavy"
    lambda_wavs[i_int_wavy] = np.float(line[1])   # wavelength of the undulations
    amp_wavs[i_int_wavy] = np.float(line[2])      # amplitude of the undulations

# read option for case-specific hard-coded tuning from extend_2D_model_to_3D.in
line = fid1.readline().strip().split()   # read new line in input file
if np.int_(line[0]) == 0 :
   case_specific_tuning = False
elif np.int_(line[0]) == 1 :
   case_specific_tuning = True
else :
   print("Error: option %i not recognized for case-specific tuning (should be 0->False or 1->True)." % line[0])
   exit("Error: unrecognized option for case-specific tuning.")

# close input files
fid1.close()
fid2.close()

#-- end read input files


#-- adapt z_min in case of topography (i.e. non-flat 1st interface)
print("input zmin = %g m" % zmin)
zmin = zmin - amp_wavs[0] - amp_bump_topo
# FL: sometimes this is not accurate (e.g. if the baseline depth of the bumpy interface is not z=0),
#     so we need to hard-code it...
if case_specific_tuning :
   zmin = 0.0
print("final zmin = %g m (with topography)" % zmin)

#-- build coordinates vectors
# (not used, just to determine nx, ny, nz)
vz = np.arange(zmin,zmax+0.1*dz,dz)
nz = len(vz)
vx = np.arange(xmin,xmax+0.1*dx,dx)
nx = len(vx)
vy = np.arange(ymin,ymax+0.1*dy,dy)
ny = len(vy)

#-- read input 2D arrays
vp_in = np.fromfile( dir_in + ("/vp_n%ix%i_h%gx%gm.bin"  % (nz,nx,dz,dx)) , dtype=np.float32 )
vs_in = np.fromfile( dir_in + ("/vs_n%ix%i_h%gx%gm.bin"  % (nz,nx,dz,dx)) , dtype=np.float32 )
rh_in = np.fromfile( dir_in + ("/rho_n%ix%i_h%gx%gm.bin" % (nz,nx,dz,dx)) , dtype=np.float32 )
qp_in = np.fromfile( dir_in + ("/qp_n%ix%i_h%gx%gm.bin"  % (nz,nx,dz,dx)) , dtype=np.float32 )
qs_in = np.fromfile( dir_in + ("/qs_n%ix%i_h%gx%gm.bin"  % (nz,nx,dz,dx)) , dtype=np.float32 )
ztopo = np.fromfile( dir_in + ("/ztopo_n%i_h%gm.bin"     % (nx,dx))       , dtype=np.float32 )

#-- reshape
vp_in = np.reshape( vp_in, (nx,nz) ).transpose()
vs_in = np.reshape( vs_in, (nx,nz) ).transpose()
rh_in = np.reshape( rh_in, (nx,nz) ).transpose()
qp_in = np.reshape( qp_in, (nx,nz) ).transpose()
qs_in = np.reshape( qs_in, (nx,nz) ).transpose()

#-- replace NaNs by vertical extrapolation of surface values
i_nans_z0 = np.where( np.isnan(vp_in[0,:]) )
if len(i_nans_z0[0]) > 0 :
   print("\nloop over %i NaNs found at z = 0." % len(i_nans_z0[0]))
for ix_nan in i_nans_z0[0] :
   i_nans_loc = np.where( np.isnan(vp_in[:,ix_nan]) )
   print("ix_nan = %i,   NaN replaced by %g" % \
                     (ix_nan, vp_in[i_nans_loc[0][-1]+1,ix_nan]))
   vp_in[i_nans_loc,ix_nan] = vp_in[i_nans_loc[0][-1]+1,ix_nan]
   vs_in[i_nans_loc,ix_nan] = vs_in[i_nans_loc[0][-1]+1,ix_nan]
   rh_in[i_nans_loc,ix_nan] = rh_in[i_nans_loc[0][-1]+1,ix_nan]
   qp_in[i_nans_loc,ix_nan] = qp_in[i_nans_loc[0][-1]+1,ix_nan]
   qs_in[i_nans_loc,ix_nan] = qs_in[i_nans_loc[0][-1]+1,ix_nan]

#-- redatum topo (SEM46 does not like negative topo values)
print("min(ztopo) = %g m" % ztopo.min())
if ztopo.min() < 0.0 :
   #z_datum = 10**np.ceil(np.log10(-ztopo.min()))   # round to next order of magnitude
   #z_datum = 100*np.ceil(-ztopo.min()/100)         # round to next multiple of 100 m
   oom = 10**np.ceil(np.log10(-ztopo.min())-1)      # find order of magnitude (oom)
   z_datum = oom*np.ceil(-ztopo.min()/oom)          # round to this order of magnitude
else :
   z_datum = 0.0
print("z_datum = %g m" % z_datum)
ztopo = ztopo + z_datum

#-- print to files
if not os.path.exists(dir_ou): os.makedirs(dir_ou)

if output_format == "bin_sem46" :
   file_ou1 = (dir_ou + "/vp_n%ix%ix%i_h%gx%gx%gm"  % (nz,nx,ny,dz,dx,dy))
   file_ou2 = (dir_ou + "/vs_n%ix%ix%i_h%gx%gx%gm"  % (nz,nx,ny,dz,dx,dy))
   file_ou3 = (dir_ou + "/rho_n%ix%ix%i_h%gx%gx%gm" % (nz,nx,ny,dz,dx,dy))
   file_ou4 = (dir_ou + "/qp_n%ix%ix%i_h%gx%gx%gm"  % (nz,nx,ny,dz,dx,dy))
   file_ou5 = (dir_ou + "/qs_n%ix%ix%i_h%gx%gx%gm"  % (nz,nx,ny,dz,dx,dy))
   file_ou6 = (dir_ou + "/ztopo_redatumed-%gm_n%ix%i_h%gx%gm"     % (z_datum,nx,ny,dx,dy))

   fid1 = open(file_ou1 + ".bin","wb")
   fid2 = open(file_ou2 + ".bin","wb")
   fid3 = open(file_ou3 + ".bin","wb")
   fid4 = open(file_ou4 + ".bin","wb")
   fid5 = open(file_ou5 + ".bin","wb")
   fid6 = open(file_ou6 + ".bin","wb")

   #-- print 2D model to file ny times
   for iy in range(0,ny) :
      fid1.write(struct.pack('f'*len(vp_in.flatten('F')), *vp_in.flatten('F')))
      fid2.write(struct.pack('f'*len(vs_in.flatten('F')), *vs_in.flatten('F')))
      fid3.write(struct.pack('f'*len(rh_in.flatten('F')), *rh_in.flatten('F')))
      fid4.write(struct.pack('f'*len(qp_in.flatten('F')), *qp_in.flatten('F')))
      fid5.write(struct.pack('f'*len(qs_in.flatten('F')), *qs_in.flatten('F')))
      fid6.write(struct.pack('f'*len(ztopo.flatten('F')), *ztopo.flatten('F')))

   fid1.close()
   fid2.close()
   fid3.close()
   fid4.close()
   fid5.close()
   fid6.close()

else :
   print("Error: unknown format %s." % output_format )


#-- copy input files to output dir for further reference
shutil.copy(file_in1, dir_ou)
shutil.copy(file_in2, dir_ou)


#-- read build_simple_synthetic_model_2D.in again, and generate the
# corresponding build_simple_synthetic_model_3D.in for further use.

# NB: this build_simple_synthetic_model_3D.in will not be entirely
# functional for use by build_simple_synthetic_model_3D.py, but it
# will contain the 3D domain size and min/max properties, which is
# enough to generate SEM46 input files.

fid_in = open(dir_in + '/build_simple_synthetic_model_2D.in','r')
fid_ou = open(dir_ou + '/build_simple_synthetic_model_3D.in','w')

lines = fid_in.readlines()

# copy the first 3 lines (dir_ou, zmin/zmax/dz, xmin/xmax/dx)
for iline in range(0,3) :
   fid_ou.write("%s" % lines[iline])

# add ymin, ymax, dy
fid_ou.write("%g %g %g   # ymin, ymax, dy (  \" )\n" % (ymin,ymax,dy) )

# copy the rest without 3D details
for iline in np.arange(3,len(lines)) :
   fid_ou.write("%s" % lines[iline])

fid_ou.write("\n")
fid_ou.write("NB: this file has been derived from a build_simple_synthetic_model_2D.in\n")
fid_ou.write("    by extend_2D_model_to_3D.py. It may not be functional for use with\n")
fid_ou.write("    build_simple_synthetic_model_3D.py but contains the 3D domain size\n")
fid_ou.write("    and min/max properties for SEM46 input files.\n")

fid_in.close()
fid_ou.close()

